#pragma once
#include <time.h>
#include <string>
#include <fstream>
#include <iostream>
#include <cstdlib>
#include <iomanip>
#include <iterator>
#include <vector>
#include <algorithm>
#include <iostream>
#include <string>

class MultiplyFunc {
private:
  double val;

public:
  MultiplyFunc(int p_toMult) :
    val(p_toMult) {
  }

  int operator ()(const int& p_toTr) const {
    return p_toTr * val;
  }
};

template<class Container> //!!! Зачем тут нужен Container_iterator, если есть Container () +
void container_printout(const Container& p_cont) {
  std::cout << "_____" << std::endl;
  unsigned int count = 1;

  std::for_each(p_cont.begin(), p_cont.end(), [&count](int p_elem) {
    std::cout << std::setw(4) << count << ")  " << std::setw(8) << p_elem << std::endl;
    count++;
    });

  std::cout << "_____" << std::endl << std::endl;
}

void CreateData_file(const std::string& filename) {
  srand(time(nullptr));
  std::ofstream file(filename);
  if (!file) {
    throw "File can't be opened";
  }
  for (int i = 0; i < 100; i++) {
    int a = rand() % 101 - 50;
    file << a << " ";
  }
}
template<typename Container>
void CreateData_iter(const std::string& filename) {
  srand(time(nullptr));
  
  using T = typename Container::value_type;
  std::vector <T> tofile(100); //!!! Функции не должны зависеть от типа контейнера +
  
  generate(tofile.begin(), tofile.end(), []() { return rand() % 101 - 50; });
  std::ofstream file2(filename);
  if (!file2) {
    throw "File can't be opened";
  }
  std::copy(tofile.begin(), tofile.end(), std::ostream_iterator <int>(file2, " "));
}

template <typename ContainerType>
void LoadData_file(ContainerType& container, const std::string& filename) {
  std::ifstream file(filename);
  if (!file) {
    throw "File can't be opened";
  }
  
  using T = typename ContainerType::value_type;
  T n; //!!! Функции не должны зависеть от конкретных типов +
  
  while (!file.eof()) {
    file >> n;
    container.push_back(n);
  }
}

template<typename ContainerType>
void LoadData_iter(ContainerType& container, const std::string& filename) {
  std::ifstream file(filename);
  if (!file) {
    throw "File can't be opened";
  }
  std::copy(std::istream_iterator<typename ContainerType::value_type>(file),
    std::istream_iterator<typename ContainerType::value_type>(), back_inserter(container));
}

template <class Type>
void Modify_1(Type& container) {
  auto sum = 0;//!!! Функции не должны зависеть от конкретных типов +
  auto sum_abs = 0;//!!! Функции не должны зависеть от конкретных типов +
  auto count = 0;//!!! Функции не должны зависеть от конкретных типов +
  auto i = container.begin();
  while ((*i) > 0)
    i++;
  auto neg = *i;//!!! Функции не должны зависеть от конкретных типов +
  double k = (neg + container[49]) / 2;

  i = container.begin();
  while (i != container.end()) {
    (*i) = (*i) / k;
    i++;
  }
  i = container.begin();
  while (i != container.end()) {
    sum += *i;
    count++;
    sum_abs += abs(*i);
    i++;
  }
  i = container.begin();
  while (i != container.end()) {
    if (*(i) == 0)
      *i = sum / count;
    i++;
  }
  container.push_back(sum_abs);
  container.push_back(sum_abs / count);
}

template <typename IteratorType>
void Modify_2(IteratorType begin, IteratorType end) {
  IteratorType i = begin;
  while ((*i) > 0)
    i++;
  int neg = *i;

  i = begin;
  for (int n = 0; n < 49; n++) { i++; };

  auto k = (neg + *i) / 2;//!!! Функции не должны зависеть от конкретных типов +
  i = begin;
  while (i != end) {
    (*i) = (*i) / k;
    i++;
  }
}

template <class Type>
void Modify_3(Type& container) {
  auto i = container.begin();
  while ((*i) > 0)
    i++;
  int neg = *i;

  auto k = (neg + container[49]) / 2;//!!! Функции не должны зависеть от конкретных типов +
  std::for_each(container.begin(), container.end(), [k](auto& cur) { cur = cur / k; });
}

template<typename Container>
bool Modify_4(const std::string& p_file_name) {
  std::ifstream Fstr_in(p_file_name);

  if (!Fstr_in.is_open()) {
    return false;
  }

  using T = typename Container::value_type;

  auto minimal = 0;//!!! Функции не должны зависеть от конкретных типов +
  T cur_num;//!!! Функции не должны зависеть от конкретных типов +

  if (!Fstr_in >> minimal) {
    return true;
  }

  while (Fstr_in >> cur_num) {
    if (minimal > cur_num) {
      minimal = cur_num;
    }
  }

  MultiplyFunc fnc(minimal);
  Fstr_in.close();
  Fstr_in.open(p_file_name);
  std::ofstream Fstr_out("modif_4");
  
  
  //!!! Функции не должны зависеть от конкретных типов (int) +
  std::transform(std::istream_iterator<T>(Fstr_in), std::istream_iterator<T>(), std::ostream_iterator<T>(Fstr_out, "\n"), fnc);

  Fstr_in.close();
  Fstr_out.close();

  return true;
}


template <typename ContainerType>
void outputResult_file(const std::string& filename, ContainerType& container) {
  std::ofstream file(filename);
  if (!file) {
    throw "File can't be opened";
  }
  for (auto& elem : container) {
    file << elem << '  ';
  }
  file.close();
  std::cout << " Result: " << std::endl;
  file.open(filename, std::ios::in);
  std::cout << file.rdbuf();
  file.close();
}

template <typename ContainerType>
void outputResult_iter(const std::string& filename, ContainerType& container) {
  std::ofstream file(filename);
  
  using T = typename ContainerType::value_type;

  //!!! Функции не должны зависеть от конкретных типов (int) +
  std::copy(container.begin(), container.end(), std::ostream_iterator <T>(file, " "));
  
  file.close();
  std::cout << " Result: " << std::endl;
  
  //!!! Функции не должны зависеть от конкретных типов (int) +
  std::ostream_iterator <T> input(std::cout, "  ");
  
  std::copy(container.begin(), container.end(), input);
}


